/// <reference types="koa-bodyparser" />
import Koa, { Middleware } from 'koa';
import { ApplicationModes } from '../Application';
import { AbstractMiddleware, MiddlewareLookupType, MiddlewareType } from '../Middleware';
export declare class ServerService {
    private readonly server;
    private readonly port;
    private middleware;
    constructor(mode: ApplicationModes, port: number, middleware: Array<Middleware | AbstractMiddleware>);
    use(...middlewares: Array<Middleware | AbstractMiddleware>): this;
    useBefore(middleware: MiddlewareLookupType, ...middlewares: Array<MiddlewareType>): this;
    useAfter(middleware: MiddlewareLookupType, ...middlewares: Array<MiddlewareType>): this;
    replace(middleware: MiddlewareLookupType, ...middlewares: Array<MiddlewareType>): this;
    updateMiddleware(at: number, remove: number, ...middlewares: Array<MiddlewareType>): this;
    indexOfMiddleware(middleware: MiddlewareLookupType): number;
    getServer(): Koa;
    start(): this;
    private asCallback;
}
